CollectionLikeType
Date: 2016-12-04

com.fasterxml.jackson.databind.type

## Class CollectionLikeType

- java.lang.Object
- - com.fasterxml.jackson.core.type.ResolvedType
  - - com.fasterxml.jackson.databind.JavaType
    - - com.fasterxml.jackson.databind.type.TypeBase
      - - com.fasterxml.jackson.databind.type.CollectionLikeType

- All Implemented Interfaces:
    JsonSerializable, java.io.Serializable, java.lang.reflect.Type
  Direct Known Subclasses:
    CollectionType

      public class CollectionLikeType
      extends TypeBase

  Type that represents things that act similar to `Collection`; but may or may not be instances of that interface. This specifically allows framework to check for configuration and annotation settings used for Map types, and pass these to custom handlers that may be more familiar with actual type.
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface com.fasterxml.jackson.databind.JsonSerializable

      `JsonSerializable.Base`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected JavaType` | `_elementType` Type of elements in collection

    - ### Fields inherited from class com.fasterxml.jackson.databind.type.TypeBase

      `_bindings, _superClass, _superInterfaces`

    - ### Fields inherited from class com.fasterxml.jackson.databind.JavaType

      `_asStatic, _class, _hash, _typeHandler, _valueHandler`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `CollectionLikeType(java.lang.Class<?> collT, TypeBindings bindings, JavaType superClass, JavaType[] superInts, JavaType elemT, java.lang.Object valueHandler, java.lang.Object typeHandler, boolean asStatic)`
    `protected` | `CollectionLikeType(TypeBase base, JavaType elemT)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected JavaType` | `_narrow(java.lang.Class<?> subclass)` Deprecated.
    `protected java.lang.String` | `buildCanonicalName()`
    `static CollectionLikeType` | `construct(java.lang.Class<?> rawType, JavaType elemT)` Deprecated. Since 2.7, use `upgradeFrom(com.fasterxml.jackson.databind.JavaType, com.fasterxml.jackson.databind.JavaType)` for constructing instances, given pre-resolved `SimpleType`.
    `static CollectionLikeType` | `construct(java.lang.Class<?> rawType, TypeBindings bindings, JavaType superClass, JavaType[] superInts, JavaType elemT)`
    `boolean` | `equals(java.lang.Object o)`
    `JavaType` | `getContentType()`
    `java.lang.Object` | `getContentTypeHandler()`
    `java.lang.Object` | `getContentValueHandler()`
    `java.lang.StringBuilder` | `getErasedSignature(java.lang.StringBuilder sb)` Method for accessing signature without generic type information, in form compatible with all versions of JVM, and specifically used for type descriptions when generating byte code.
    `java.lang.StringBuilder` | `getGenericSignature(java.lang.StringBuilder sb)`
    `boolean` | `hasHandlers()` Helper method that checks whether this type, or its (optional) key or content type has `JavaType.getValueHandler()` or `JavaType.getTypeHandler()`; that is, are there any non-standard handlers associated with this type object.
    `boolean` | `isCollectionLikeType()`
    `boolean` | `isContainerType()`
    `boolean` | `isTrueCollectionType()` Method that can be used for checking whether this type is a "real" Collection type; meaning whether it represents a parameterized subtype of `Collection` or just something that acts like one.
    `JavaType` | `refine(java.lang.Class<?> rawType, TypeBindings bindings, JavaType superClass, JavaType[] superInterfaces)` Mutant factory method that will try to create and return a sub-type instance for known parameterized types; for other types will return `null` to indicate that no just refinement makes necessary sense, without trying to detect special status through implemented interfaces.
    `java.lang.String` | `toString()`
    `static CollectionLikeType` | `upgradeFrom(JavaType baseType, JavaType elementType)` Factory method that can be used to "upgrade" a basic type into collection-like one; usually done via `TypeModifier`
    `JavaType` | `withContentType(JavaType contentType)` Mutant factory method that may be called on structured types that have a so-called content type (element of arrays, value type of Maps, referenced type of referential types), and will construct a new instance that is identical to this instance, except that it has specified content type, instead of current one.
    `CollectionLikeType` | `withContentTypeHandler(java.lang.Object h)` Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified content type (element type for arrays, value type for Maps and so forth) handler assigned.
    `CollectionLikeType` | `withContentValueHandler(java.lang.Object h)` Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified content value handler assigned.
    `JavaType` | `withHandlersFrom(JavaType src)` Mutant factory method that will try to copy handlers that the specified source type instance had, if any; this must be done recursively where necessary (as content types may be structured).
    `CollectionLikeType` | `withStaticTyping()` Method that can be called to get a type instance that indicates that values of the type should be handled using "static typing" for purposes of serialization (as opposed to "dynamic" aka runtime typing): meaning that no runtime information is needed for determining serializers to use.
    `CollectionLikeType` | `withTypeHandler(java.lang.Object h)` "Copy method" that will construct a new instance that is identical to this instance, except that it will have specified type handler assigned.
    `CollectionLikeType` | `withValueHandler(java.lang.Object h)` Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified value handler assigned.

    - ### Methods inherited from class com.fasterxml.jackson.databind.type.TypeBase

      `_bogusSuperClass, _classSignature, containedType, containedTypeCount, containedTypeName, findSuperType, findTypeParameters, getBindings, getInterfaces, getSuperClass, serialize, serializeWithType, toCanonical`

    - ### Methods inherited from class com.fasterxml.jackson.databind.JavaType

      `containedTypeOrUnknown, forcedNarrowBy, getErasedSignature, getGenericSignature, getKeyType, getParameterSource, getRawClass, getReferencedType, getTypeHandler, getValueHandler, hasContentType, hasGenericTypes, hashCode, hasRawClass, hasValueHandler, isAbstract, isArrayType, isConcrete, isEnumType, isFinal, isInterface, isJavaLangObject, isMapLikeType, isPrimitive, isThrowable, isTypeOrSubTypeOf, useStaticType`

    - ### Methods inherited from class com.fasterxml.jackson.core.type.ResolvedType

      `isReferenceType`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### _elementType

          protected final JavaType _elementType

      Type of elements in collection

  - ### Constructor Detail

    - #### CollectionLikeType

          protected CollectionLikeType(java.lang.Class<?> collT,
                            TypeBindings bindings,
                            JavaType superClass,
                            JavaType[] superInts,
                            JavaType elemT,
                            java.lang.Object valueHandler,
                            java.lang.Object typeHandler,
                            boolean asStatic)

    - #### CollectionLikeType

          protected CollectionLikeType(TypeBase base,
                            JavaType elemT)

      Since:
        2.7

  - ### Method Detail

    - #### construct

          public static CollectionLikeType construct(java.lang.Class<?> rawType,
                                     TypeBindings bindings,
                                     JavaType superClass,
                                     JavaType[] superInts,
                                     JavaType elemT)

      Since:
        2.7

    - #### construct

          @Deprecated
          public static CollectionLikeType construct(java.lang.Class<?> rawType,
                                                JavaType elemT)

      Deprecated. Since 2.7, use `upgradeFrom(com.fasterxml.jackson.databind.JavaType, com.fasterxml.jackson.databind.JavaType)` for constructing instances, given pre-resolved `SimpleType`.

    - #### upgradeFrom

          public static CollectionLikeType upgradeFrom(JavaType baseType,
                                       JavaType elementType)

      Factory method that can be used to "upgrade" a basic type into collection-like one; usually done via `TypeModifier`
      Since:
        2.7

    - #### _narrow

          @Deprecated
          protected JavaType _narrow(java.lang.Class<?> subclass)

      Deprecated.
      Specified by:
        `_narrow` in class `JavaType`

    - #### withContentType

          public JavaType withContentType(JavaType contentType)

      Description copied from class: `JavaType`
      Mutant factory method that may be called on structured types that have a so-called content type (element of arrays, value type of Maps, referenced type of referential types), and will construct a new instance that is identical to this instance, except that it has specified content type, instead of current one. If content type is already set to given type, `this` is returned. If type does not have a content type (which is the case with `SimpleType`), `IllegalArgumentException` will be thrown.
      Specified by:
        `withContentType` in class `JavaType`
      Returns:
        Newly created type instance

    - #### withTypeHandler

          public CollectionLikeType withTypeHandler(java.lang.Object h)

      Description copied from class: `JavaType`
      "Copy method" that will construct a new instance that is identical to this instance, except that it will have specified type handler assigned.
      Specified by:
        `withTypeHandler` in class `JavaType`
      Returns:
        Newly created type instance

    - #### withContentTypeHandler

          public CollectionLikeType withContentTypeHandler(java.lang.Object h)

      Description copied from class: `JavaType`
      Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified content type (element type for arrays, value type for Maps and so forth) handler assigned.
      Specified by:
        `withContentTypeHandler` in class `JavaType`
      Returns:
        Newly created type instance, with given

    - #### withValueHandler

          public CollectionLikeType withValueHandler(java.lang.Object h)

      Description copied from class: `JavaType`
      Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified value handler assigned.
      Specified by:
        `withValueHandler` in class `JavaType`
      Returns:
        Newly created type instance

    - #### withContentValueHandler

          public CollectionLikeType withContentValueHandler(java.lang.Object h)

      Description copied from class: `JavaType`
      Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified content value handler assigned.
      Specified by:
        `withContentValueHandler` in class `JavaType`
      Returns:
        Newly created type instance

    - #### withHandlersFrom

          public JavaType withHandlersFrom(JavaType src)

      Description copied from class: `JavaType`
      Mutant factory method that will try to copy handlers that the specified source type instance had, if any; this must be done recursively where necessary (as content types may be structured).
      Overrides:
        `withHandlersFrom` in class `JavaType`

    - #### withStaticTyping

          public CollectionLikeType withStaticTyping()

      Description copied from class: `JavaType`
      Method that can be called to get a type instance that indicates that values of the type should be handled using "static typing" for purposes of serialization (as opposed to "dynamic" aka runtime typing): meaning that no runtime information is needed for determining serializers to use. The main use case is to allow forcing of specific root value serialization type, and specifically in resolving serializers for contained types (element types for arrays, Collections and Maps).
      Specified by:
        `withStaticTyping` in class `JavaType`

    - #### refine

          public JavaType refine(java.lang.Class<?> rawType,
                        TypeBindings bindings,
                        JavaType superClass,
                        JavaType[] superInterfaces)

      Description copied from class: `JavaType`
      Mutant factory method that will try to create and return a sub-type instance for known parameterized types; for other types will return `null` to indicate that no just refinement makes necessary sense, without trying to detect special status through implemented interfaces.
      Specified by:
        `refine` in class `JavaType`

    - #### isContainerType

          public boolean isContainerType()

      Specified by:
        `isContainerType` in class `JavaType`
      Returns:
        True if type represented is a container type; this includes array, Map and Collection types.

    - #### isCollectionLikeType

          public boolean isCollectionLikeType()

      Overrides:
        `isCollectionLikeType` in class `JavaType`
      Returns:
        True if type is either true `Collection` type, or something similar (meaning it has at least one type parameter, which describes type of contents)

    - #### getContentType

          public JavaType getContentType()

      Overrides:
        `getContentType` in class `JavaType`

    - #### getContentValueHandler

          public java.lang.Object getContentValueHandler()

      Overrides:
        `getContentValueHandler` in class `JavaType`

    - #### getContentTypeHandler

          public java.lang.Object getContentTypeHandler()

      Overrides:
        `getContentTypeHandler` in class `JavaType`

    - #### hasHandlers

          public boolean hasHandlers()

      Description copied from class: `JavaType`
      Helper method that checks whether this type, or its (optional) key or content type has `JavaType.getValueHandler()` or `JavaType.getTypeHandler()`; that is, are there any non-standard handlers associated with this type object.
      Overrides:
        `hasHandlers` in class `JavaType`

    - #### getErasedSignature

          public java.lang.StringBuilder getErasedSignature(java.lang.StringBuilder sb)

      Description copied from class: `JavaType`
      Method for accessing signature without generic type information, in form compatible with all versions of JVM, and specifically used for type descriptions when generating byte code.
      Specified by:
        `getErasedSignature` in class `TypeBase`
      Parameters:
        `sb` - StringBuilder to append signature to
      Returns:
        StringBuilder that was passed in; returned to allow call chaining

    - #### getGenericSignature

          public java.lang.StringBuilder getGenericSignature(java.lang.StringBuilder sb)

      Specified by:
        `getGenericSignature` in class `TypeBase`
      Parameters:
        `sb` - StringBuilder to append signature to
      Returns:
        StringBuilder that was passed in; returned to allow call chaining

    - #### buildCanonicalName

          protected java.lang.String buildCanonicalName()

      Overrides:
        `buildCanonicalName` in class `TypeBase`

    - #### isTrueCollectionType

          public boolean isTrueCollectionType()

      Method that can be used for checking whether this type is a "real" Collection type; meaning whether it represents a parameterized subtype of `Collection` or just something that acts like one.

    - #### equals

          public boolean equals(java.lang.Object o)

      Specified by:
        `equals` in class `JavaType`

    - #### toString

          public java.lang.String toString()

      Specified by:
        `toString` in class `JavaType`